<% html_title t('captcha.label_captcha') %>
<% breadcrumb_paths(t('captcha.label_captcha')) %>
<div id="login-form" class="form -bordered">
  <%= styled_form_tag({ action: :verify }, { :autocomplete => "off", :id => 'submit_captcha' }) do %>
    <h2><%= t 'recaptcha.verify_account' %></h2>
    <% if [Nepenthes::Captcha::TYPE_RECAPTCHA_V2, Nepenthes::Captcha::TYPE_HCAPTCHA].include?(recaptcha_settings['captcha_type']) %>
      <% input_name = "g-recaptcha-response" %>
      <input type="hidden" name="<%= input_name %>" />
      <%= recaptcha_tags(
        nonce: content_security_policy_script_nonce,
        callback: 'submitRecaptchaForm',
        site_key: recaptcha_settings['website_key'],
      ) %>

      <%= nonced_javascript_tag do %>
        function submitRecaptchaForm(val) {
          var input = document.getElementById('<%= input_name %>');

          if (!input) { // hcaptcha uses name, not ID
            var inputs = document.getElementsByName('<%= input_name %>');

            if (inputs.length > 0) {
              input = inputs[0];
            }
          }

          input.value = val;
          document.getElementById('submit_captcha').submit();
        }
      <% end %>
    <% elsif recaptcha_settings['captcha_type'] == ::Nepenthes::Captcha::TYPE_RECAPTCHA_V3 %>
      <%= recaptcha_v3 action: 'login',
                       nonce: content_security_policy_script_nonce,
                       callback: 'submitRecaptchaForm',
                       site_key: recaptcha_settings['website_key'] %>

      <p><%= t('captcha.button_please_wait') %></p>
      <%= nonced_javascript_tag do %>
        function submitRecaptchaForm(id, val) {
          document.getElementById(id).value = val;
          document.getElementById('submit_captcha').submit();
        }
      <% end %>
    <% elsif recaptcha_settings['captcha_type'] == ::Nepenthes::Captcha::TYPE_TURNSTILE %>
      <% input_name = "turnstile-response" %>
      <input type="hidden" name="<%= input_name %>" />
      <script src="https://challenges.cloudflare.com/turnstile/v0/api.js?onload=onloadTurnstileCallback" defer></script>
      
      <div id="turnstile-container"></div>
      <%= nonced_javascript_tag do %>
        function submitTurnstileForm(token) {
          var input = document.getElementsByName('<%= input_name %>')[0];

          input.value = token;
          document.getElementById('submit_captcha').submit();
        }
        
        window.onloadTurnstileCallback = function () {
          turnstile.render('#turnstile-container', {
            sitekey: '<%= recaptcha_settings['website_key'] %>',
            callback: submitTurnstileForm,
          });
        };
      <% end %>
    <% end %>
  <% end %>
</div>
